﻿//////////////////////////////////////////////////////////////////
//Andrzej Fałkowski 119315
//////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace ZemstaSamuela
{

    public partial class Form1 : Form
    {
        //public int[,] board = new int[8, 8];
        const int BOARD_SIZE = 8;

        const int WHITE_PLAYER = 1;
        const int BLACK_PLAYER = 2;
        const int BLOCKED = -1;
        const int EMPTY = 0;
        const int WHITE_PAWN = 1;
        const int BLACK_PAWN = 2;
        const int WHITE_KING = 10;
        const int BLACK_KING = 20;

        const float RANDOMNESS = 10000.0f;

        const float WIN_VALUE = 10000.0f;
        const float DRAW_VALUE = 5000.0f;
        const float LOSE_VALUE = -10000.0f;

        const int TREE_DEPTH = 1;
        const float ALPHA = -15.0f;

        public int[] board = new int[64];
        public int[] temp_board = new int[64];
        public int[][]possible_boards = new int [128][];

        public int possible_board_count = 0;

        public bool debug_mode = true;
        public bool enforced_kills = true;
        public bool notation = true;
        public bool official_notation = false;
        public bool refresh = true;
        public int wait_time = 100;
        public int clones=5;
        public int autos = 10;


        public int current_move = 0;
        public int current_player = WHITE_PLAYER;

        public bool game_over = false;

        public int black_pawn_count = BOARD_SIZE;
        public int white_pawn_count = BOARD_SIZE;

        public float[] pawn_value = { 1.0f,1.0f };
        public float[] king_multiplier = { 2.0f, 2.0f };
        public float[] border_multiplier = { 0.1f, 0.1f };
        public float[] corner_multiplier = { 0.2f, 0.2f };
        public float[] center_multiplier = { 1.2f, 1.2f };
        public float[] distance_multiplier = { 1.01f, 1.01f };

        public float[] attack_multiplier = { 1.1f, 1.1f };
        public float[] danger_multiplier = { 0.3f, 0.3f };
        public float[] defense_multiplier = { 1.1f, 1.1f };
        public float[] aggresivity_multiplier = { 1.0f, 1.0f };
        public float[] time_multiplier = { 0.001f, 0.001f };



        public int start_position = 0;
        public int next_position = 0;
        Random random = new Random();

        void clear_possible_boards()
        {
            possible_board_count = 0;
            for (int i = 0; i < 128; i++)
            {
                possible_boards[i] = new int[BOARD_SIZE * BOARD_SIZE];
            }
        }
        int check_board(int[]current_board,int area)
        {
            if (area < 0 || area > BOARD_SIZE * BOARD_SIZE - 1)
                return BLOCKED;
            else return current_board[area];
        }
        int check_next_board(int[] checked_board,int area)
        {
            if (area < 0 || area > BOARD_SIZE * BOARD_SIZE  -1)
                return BLOCKED;
            else return checked_board[area];
        }

        int check_winner(int[] checked_board)
        {
            int white_pawns = 0;
            int black_pawns = 0;
            if (current_move > 100)
                return 0;
            for (int i = 0; i < 64; i++)
            {
                if (checked_board[i] == WHITE_PAWN || checked_board[i] == WHITE_KING)
                {
                    white_pawns++;
                }
                else if (checked_board[i] == BLACK_PAWN || checked_board[i] == BLACK_KING)
                {
                    black_pawns++;
                }
            }
            if (get_moves(checked_board, WHITE_PLAYER) == null || get_moves(checked_board, BLACK_PLAYER) == null || black_pawns==1 || white_pawns==1)
            {

                if ((white_pawns > 0 && black_pawns == 0) || (black_pawns == 1 && white_pawns > 1))
                {
                    //matchHistory.Text += "WW\n";
                    return WHITE_PLAYER;
                }
                else if ((white_pawns == 0 && black_pawns > 0) || (white_pawns == 1 && black_pawns > 1))
                {
                    //matchHistory.Text += "BW\n";
                    return BLACK_PLAYER;
                }
                else
                {
                    //matchHistory.Text += "Draw\n";
                    return 0;
                }
            }
            else
            {
                
                return -1;
            }
                
        }
        void reset_board()
        {
            current_move = 0;
            game_over = false;
            for (int i = 0; i < BOARD_SIZE * BOARD_SIZE; i++)
            {
                board[i] = EMPTY;
            }
            for (int i = 1; i < BOARD_SIZE; i += 2)
            {
                board[i] = BLACK_PAWN;
            }
            for (int i = BOARD_SIZE; i < BOARD_SIZE * 2; i += 2)
            {
                board[i] = BLACK_PAWN;
            }
            for (int i = BOARD_SIZE * BOARD_SIZE - (BOARD_SIZE*2)+1; i < BOARD_SIZE * (BOARD_SIZE - 1); i += 2)
            {
                board[i] = WHITE_PAWN;
            }
            for (int i = BOARD_SIZE * (BOARD_SIZE - 1); i < BOARD_SIZE * BOARD_SIZE; i += 2)
            {
                board[i] = WHITE_PAWN;
            }
            if (!debug_mode) button_bm.Enabled = false;
        }
        void update_board_presentation()
        {
            boardPicture.Refresh();
            Bitmap bitmap = new Bitmap("checkers_board.png");
            Graphics g = Graphics.FromImage(bitmap);//boardPicture.CreateGraphics();
            Pen whitePen = new Pen(Color.White, 3);
            Pen blackPen = new Pen(Color.Black, 3);
            for (int i = 0; i < BOARD_SIZE * BOARD_SIZE; i++)
            {
                if (official_notation == false)
                {
                    g.DrawString(i.ToString(), new System.Drawing.Font("Arial", 16),
                        new System.Drawing.SolidBrush(System.Drawing.Color.Black), (i % BOARD_SIZE) * 40 + 8, (i / BOARD_SIZE) * 40 + 8);
                }
                else
                {
                    if ((i % BOARD_SIZE + i / BOARD_SIZE) % 2 == 1)
                    {
                        g.DrawString((i / 2 + 1).ToString(), new System.Drawing.Font("Arial", 16),
                            new System.Drawing.SolidBrush(System.Drawing.Color.Black), (i % BOARD_SIZE) * 40 + 8, (i / BOARD_SIZE) * 40 + 8);
                    }
                }
                if (board[i] == WHITE_PAWN)
                {
                    g.DrawEllipse(whitePen, (i % BOARD_SIZE) * 40 + 4, (i / BOARD_SIZE) * 40 + 4, 32, 32);// (i % 4), (i % 4), (i % 4) + 40, (i % 4) + 40);
                    //g.DrawRectangle(whitePen, (i % 8) * 40 + 4, (i / 8) * 40 + 4, 32, 32);
                }
                else if (board[i] == BLACK_PAWN)
                {
                    g.DrawEllipse(blackPen, (i % BOARD_SIZE) * 40 + 4, (i / BOARD_SIZE) * 40 + 4, 32, 32);
                }
                else if (board[i] == WHITE_KING)
                {
                    g.DrawRectangle(whitePen, (i % BOARD_SIZE) * 40 + 4, (i / BOARD_SIZE) * 40 + 4, 32, 32);
                }
                if (board[i] == BLACK_KING)
                {
                    g.DrawRectangle(blackPen, (i % BOARD_SIZE) * 40 + 4, (i / BOARD_SIZE) * 40 + 4, 32, 32);
                }
            }  
            boardPicture.Image = bitmap;
            boardPicture.Refresh();
            //boardPicture.Image = g;
        }
        float estimate_board(int[] estimated_board,int who, int by_who)
        {

            //matchHistory.Text = "";
            float estimation = 0.0f;
            float[] player_estimations = new float[2];
            int myPawn = 0;
            int enemyPawn = 0;
            int myKing = 0;
            int enemyKing = 0;
            if ((estimated_board == null) || (get_moves(estimated_board, who) == null))
            {
                if (check_winner(estimated_board) == 0)
                {
                    return DRAW_VALUE;
                }
                else if (check_winner(estimated_board) == who)
                {
                    return WIN_VALUE;
                }
                else if (check_winner(estimated_board) == who % 2 + 1)
                {
                    return LOSE_VALUE;
                }
            }
            //else if()

            for (int j = 0; j < 2;j++ )
            {
                if (who == WHITE_PLAYER)
                {
                    myPawn = WHITE_PAWN;
                    myKing = WHITE_KING;
                    enemyPawn = BLACK_PAWN;
                    enemyKing = BLACK_KING;
                }
                else
                {
                    myPawn = BLACK_PAWN;
                    myKing = BLACK_KING;
                    enemyPawn = WHITE_PAWN;
                    enemyKing = WHITE_KING;
                }
                for (int i = 0; i < BOARD_SIZE * BOARD_SIZE; i++)
                {
                    if (estimated_board[i] == myKing || estimated_board[i] == myPawn)
                    {
                        int what = estimated_board[i];
                        float current_pawn_value;
                        if (by_who == WHITE_PLAYER)
                            current_pawn_value = pawn_value[0];
                        else
                            current_pawn_value = pawn_value[1];

                        if (estimated_board[i] == myKing)
                        {
                            if (by_who == WHITE_PLAYER)
                                current_pawn_value *= king_multiplier[0];
                            else
                                current_pawn_value *= king_multiplier[1];

                        }

                        if (i % BOARD_SIZE == 0 || i % BOARD_SIZE == BOARD_SIZE - 1)
                        {
                            if (by_who == WHITE_PLAYER)
                                current_pawn_value += border_multiplier[0] * (1.0f - aggresivity_multiplier[0]);

                            else
                                current_pawn_value += border_multiplier[1] * (1.0f - aggresivity_multiplier[1]);

                        }
                        if (i == 7 || i == 56)
                        {
                            
                            if (by_who == WHITE_PLAYER)
                            {
                                //matchHistory.Text += "56\n";                            
                                current_pawn_value += corner_multiplier[0] * (aggresivity_multiplier[0] - 1.0f);
                                //matchHistory.Text += i.ToString() + " : " + current_pawn_value.ToString() + "\n";
                            }

                            else
                                current_pawn_value += corner_multiplier[1] * (aggresivity_multiplier[1] - 1.0f);
                        }

                        if (i == 35 || i == 28)
                        {
                            if (by_who == WHITE_PLAYER)
                                current_pawn_value *= center_multiplier[0];
                            else
                                current_pawn_value *= center_multiplier[1];
                        }

                        //pion atakuje wroga
                        int move_direction = 0;
                        if (who == WHITE_PLAYER)
                        {
                            move_direction = -1;
                        }
                        else
                        {
                            move_direction = 1;
                        }
                        if ((i / BOARD_SIZE == (i + (BOARD_SIZE - 1) * move_direction) / BOARD_SIZE - move_direction)
                            && ((check_board(estimated_board, i + (BOARD_SIZE - 1) * move_direction) == enemyPawn) ||
                                (check_board(estimated_board, i + (BOARD_SIZE - 1) * move_direction) == enemyKing))
                        && (i / BOARD_SIZE == (i + ((BOARD_SIZE - 1) * 2) * move_direction) / BOARD_SIZE - 2 * move_direction)
                        && (check_board(estimated_board, i + ((BOARD_SIZE - 1) * 2) * move_direction) == EMPTY))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= attack_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= attack_multiplier[1];
                            }
                        }
                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction)
                            && ((check_board(estimated_board, i + 9 * move_direction) == enemyPawn) ||
                                (check_board(estimated_board, i + 9 * move_direction) == enemyKing))
                        && (i / 8 == (i + ((BOARD_SIZE + 1) * 2) * move_direction) / 8 - 2 * move_direction)
                        && (check_board(estimated_board, i + ((BOARD_SIZE + 1) * 2) * move_direction) == EMPTY))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= attack_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= attack_multiplier[1];
                            }
                        }
                        if (what == myKing)
                        {
                            move_direction = -move_direction;
                            if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction)
                                && ((check_board(estimated_board, i + 7 * move_direction) == enemyPawn) ||
                                    (check_board(estimated_board, i + 7 * move_direction) == enemyKing))
                            && (i / 8 == (i + 14 * move_direction) / 8 - 2 * move_direction)
                            && (check_board(estimated_board, i + 14 * move_direction) == EMPTY))
                            {
                                if (by_who == WHITE_PLAYER)
                                {
                                    current_pawn_value *= attack_multiplier[0];
                                }
                                else
                                {
                                    current_pawn_value *= attack_multiplier[1];
                                }
                            }
                            if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction)
                                && ((check_board(estimated_board, i + 9 * move_direction) == enemyPawn) ||
                                    (check_board(estimated_board, i + 9 * move_direction) == enemyKing))
                            && (i / 8 == (i + 18 * move_direction) / 8 - 2 * move_direction)
                            && (check_board(estimated_board, i + 18 * move_direction) == EMPTY))
                            {
                                if (by_who == WHITE_PLAYER)
                                {
                                    current_pawn_value *= attack_multiplier[0];
                                }
                                else
                                {
                                    current_pawn_value *= attack_multiplier[1];
                                }
                            }
                        }


                        //pion broni innego piona
                        if (who == WHITE_PLAYER)
                        {
                            move_direction = -1;
                        }
                        else
                        {
                            move_direction = 1;
                        }
                        if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction) &&
                            ((check_board(board, i + 7 * move_direction) == myPawn) || (check_board(board, i + 7 * move_direction) == myKing)))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= defense_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= defense_multiplier[1];
                            }
                        }
                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction) &&
                            ((check_board(board, i + 9 * move_direction) == myPawn) || (check_board(board, i + 9 * move_direction) == myKing)))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= defense_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= defense_multiplier[1];
                            }
                        }

                        //pion zagrozony
                        if (who == WHITE_PLAYER)
                        {
                            move_direction = -1;
                        }
                        else
                        {
                            move_direction = 1;
                        }
                        if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction) &&
                            (check_board(board, i + 7 * move_direction) == enemyPawn))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= danger_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= danger_multiplier[1];
                            }
                        }
                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction) &&
                            (check_board(board, i + 9 * move_direction) == enemyPawn))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= danger_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= danger_multiplier[1];
                            }
                        }
                        move_direction = -move_direction;
                        if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction) &&
                            ((check_board(board, i + 7 * move_direction) == enemyKing)))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= danger_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= danger_multiplier[1];
                            }
                        }
                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction) &&
                            (check_board(board, i + 9 * move_direction) == enemyKing))
                        {
                            if (by_who == WHITE_PLAYER)
                            {
                                current_pawn_value *= danger_multiplier[0];
                            }
                            else
                            {
                                current_pawn_value *= danger_multiplier[1];
                            }
                        }

                        //przebyty dystans do awansu (tylko piony)
                        if (who == WHITE_PLAYER)
                        {
                            move_direction = -1;
                        }
                        else
                        {
                            move_direction = 1;
                        }
                        if (what == myPawn)
                        {
                            if (who == WHITE_PLAYER)
                            {
                                float d_m = 0.0f;                            
                                float t_m = 0.0f;
                                if (by_who == WHITE_PLAYER)
                                {
                                    t_m = time_multiplier[0];
                                    d_m = distance_multiplier[0];
                                }
                                else
                                {
                                    t_m = time_multiplier[1];
                                    d_m = distance_multiplier[1];
                                }
                                for(int k = 0;k<(7 - (i / 8));k++)
                                {
                                    d_m=d_m*d_m;
                                }
                                //matchHistory.Text += "d_m: "+d_m.ToString()+"\n";
                                current_pawn_value += d_m *t_m * current_move;
                                //current_pawn_value *= 1.0f;
                                //current_pawn_value *= 1.0f + (7 - (i / 8)) * distance_multiplier[0] * time_multiplier[0] * current_move;
                                //matchHistory.Text += i.ToString() + " 1: " + current_pawn_value.ToString() + "\n";// +distance_multiplier[0].ToString() + "\n";

                            }
                            else
                            {
                                float d_m = 0.0f;
                                float t_m = 0.0f;
                                if (by_who == WHITE_PLAYER)
                                {
                                    t_m = time_multiplier[0];
                                    d_m = distance_multiplier[0];
                                }
                                else
                                {
                                    t_m = time_multiplier[1];
                                    d_m = distance_multiplier[1];
                                }
                                for(int k = 0;k<(i / 8);k++)
                                {
                                    d_m = d_m * d_m;
                                }
                                //matchHistory.Text += "d_m: " + d_m.ToString() + "\n";
                                current_pawn_value += d_m *t_m * current_move;
                                //current_pawn_value *= 1.0f;
                                //current_pawn_value *= 1.0f + ((i / 8)) * distance_multiplier[1] * time_multiplier[1] * current_move;
                                //matchHistory.Text += i.ToString() + " 2: " + current_pawn_value.ToString() + "\n";// +distance_multiplier[1].ToString() + "\n";
                            }
                        }
                        //matchHistory.Text += i.ToString() + " : " + current_pawn_value.ToString() + "\n";
                        player_estimations[j] += current_pawn_value;
                        
                    }
                   
                    
                }
                
                who = who % 2 + 1;
            }
            if (by_who == WHITE_PLAYER)
            {
                estimation = player_estimations[0] - player_estimations[1]*aggresivity_multiplier[0];
            }
            else
            {
                estimation = player_estimations[0] - player_estimations[1] * aggresivity_multiplier[1];
            }
            //matchHistory.Text += "estymacja\n";
            estimation += (float)random.NextDouble()/RANDOMNESS;
            //matchHistory.Text += estimation.ToString("0.00000") + " ";
            return estimation;
        }


        public Form1()
        {
            InitializeComponent();
            showValues();
        }

        private void button_reset_Click(object sender, EventArgs e)
        {
            reset_board();
            current_move = 0;
            current_player = WHITE_PLAYER;
            update_board_presentation();
            if(notation)
                matchHistory.Text = "";
            //matchHistory.Text += "Start\n";
        }

        int[] arraytoarray(int[] target, int[] source)
        {
            
            for (int i = 0; i < 64; i++)
            {
                target[i] = source[i];
            }
            return target;
        }

        int[] get_attacks(int[] current_board, int pos,int who,int what)
        {
            int myPawn = 0;
            int enemyPawn = 0;
            int myKing = 0;
            int enemyKing = 0;
            int move_direction = 0;
            bool nope1 = true;
            bool nope2 = true;
            bool nope3 = true;
            bool nope4 = true;
            if (who == WHITE_PLAYER)
            {
                myPawn = WHITE_PAWN;
                myKing = WHITE_KING;
                enemyPawn = BLACK_PAWN;
                enemyKing = BLACK_KING;
                move_direction = -1;
            }
            else
            {
                myPawn = BLACK_PAWN;
                myKing = BLACK_KING;
                enemyPawn = WHITE_PAWN;
                enemyKing = WHITE_KING;
                move_direction = 1;
            }
            
            if((pos / 8 == (pos + 7 * move_direction) / 8 - move_direction)
               &&((check_next_board(current_board, pos + 7 * move_direction) == enemyPawn)||
                           (check_next_board(current_board, pos + 7 * move_direction) == enemyKing))
               &&(pos / 8 == (pos + 14 * move_direction) / 8 - 2 * move_direction) 
               &&(check_next_board(current_board, pos + 14 * move_direction) == EMPTY))
            {
                //matchHistory.Text += "\nnope1\n";
                nope1=false;
                int[] after_kill_board = new int[64];
                Array.Copy(current_board, after_kill_board, 64);
                if ((who == WHITE_PLAYER && (pos + 14 * move_direction) / 8 == 0)
                || (who == BLACK_PLAYER && (pos + 14 * move_direction) / 8 == 7))
                {
                    what = myKing;
                }
                after_kill_board[pos + 14 * move_direction] = what;
                after_kill_board[pos + 7 * move_direction] = EMPTY;
                after_kill_board[pos] = EMPTY;
                get_attacks(after_kill_board, pos + 14 * move_direction, who, what);
            }
            if ((pos / 8 == (pos + 9 * move_direction) / 8 - move_direction)
               && ((check_next_board(current_board, pos + 9 * move_direction) == enemyPawn) ||
                           (check_next_board(current_board, pos + 9 * move_direction) == enemyKing))
               && (pos / 8 == (pos + 18 * move_direction) / 8 - 2 * move_direction)
               && (check_next_board(current_board, pos + 18 * move_direction) == EMPTY))
            {
                //matchHistory.Text += "\nnope2\n";
                nope2 = false;
                int[] after_kill_board = new int[64];
                Array.Copy(current_board, after_kill_board, 64);
                if ((who == WHITE_PLAYER && (pos + 18 * move_direction) / 8 == 0)
                || (who == BLACK_PLAYER && (pos + 18 * move_direction) / 8 == 7))
                {
                    what = myKing;
                }
                after_kill_board[pos + 18 * move_direction] = what;
                after_kill_board[pos + 9 * move_direction] = EMPTY;
                after_kill_board[pos] = EMPTY;
                get_attacks(after_kill_board, pos + 18 * move_direction, who, what);
            }
            move_direction *= (-1);
            if ((pos / 8 == (pos + 7 * move_direction) / 8 - move_direction)
               && ((check_next_board(current_board, pos + 7 * move_direction) == enemyPawn) ||
                           (check_next_board(current_board, pos + 7 * move_direction) == enemyKing))
               && (pos / 8 == (pos + 14 * move_direction) / 8 - 2 * move_direction)
               && (check_next_board(current_board, pos + 14 * move_direction) == EMPTY))
            {
                //matchHistory.Text += "\nnope3\n";
                nope3 = false;
                int[] after_kill_board = new int[64];
                Array.Copy(current_board, after_kill_board, 64);
                if ((who == WHITE_PLAYER && (pos + 14 * move_direction) / 8 == 0)
                || (who == BLACK_PLAYER && (pos + 14 * move_direction) / 8 == 7))
                    what = myKing;
                after_kill_board[pos + 14 * move_direction] = what;

                after_kill_board[pos + 7 * move_direction] = EMPTY;
                after_kill_board[pos] = EMPTY;
                get_attacks(after_kill_board, pos + 14 * move_direction, who, what);
            }
            if ((pos / 8 == (pos + 9 * move_direction) / 8 - move_direction)
               && ((check_next_board(current_board, pos + 9 * move_direction) == enemyPawn) ||
                           (check_next_board(current_board, pos + 9 * move_direction) == enemyKing))
               && (pos / 8 == (pos + 18 * move_direction) / 8 - 2 * move_direction)
               && (check_next_board(current_board, pos + 18 * move_direction) == EMPTY))
            {
                //matchHistory.Text += "\nnope4\n";
                nope4 = false;
                int[] after_kill_board = new int[64];
                Array.Copy(current_board, after_kill_board, 64);

                if ((who == WHITE_PLAYER && (pos + 18 * move_direction) / 8 == 0)
                || (who == BLACK_PLAYER && (pos + 18 * move_direction) / 8 == 7))
                    what = myKing;
                after_kill_board[pos + 18 * move_direction] = what;
                after_kill_board[pos + 9 * move_direction] = EMPTY;
                after_kill_board[pos] = EMPTY;
                get_attacks(after_kill_board, pos + 14 * move_direction, who, what);
            }
            if (nope1 && nope2 && nope3 && nope4)
            {

                //matchHistory.Text += "\nkoniec mozliwosci, wrzuc\n";
                Array.Copy(current_board, possible_boards[possible_board_count], 64);
                possible_board_count++;
                return current_board;
            }
            return null;
        }


        int[] get_best_move(int[][] possible_moves, int count, int who)
        {
            if (possible_moves == null) return null;

            float max_estimation = -32000;
            int[] best_move = new int [64];
            int best_estimation = 0;
            for (int i = 0; i < count; i++)
            {
                //matchHistory.Text += "curr_est\n";
                float current_estimation = estimate_board(possible_moves[i],who,who);
                if (current_estimation > max_estimation)
                {
                    best_estimation = i;
                    max_estimation = current_estimation;
                    Array.Copy(possible_moves[i], best_move, 64);
                }
            }
            int temp = 0;
            return possible_moves[best_estimation];

        }

        int [][] get_moves(int[] current_board, int who)
        {
            int[] next_board = new int[64];
            int[] best_board = new int[64];

            int[][] possible_moves = new int[128][];
            int possible_move_count = 0;

            for (int i = 0; i < 128; i++)
            {
                possible_moves[i] = new int[64];
            }

            possible_board_count = 0;
            bool is_attack_possible = false;

            Array.Copy(current_board, best_board, 64);

            //float max_estimation = -32765;
            int myPawn = 0;
            int enemyPawn = 0;
            int myKing = 0;
            int enemyKing = 0;
            int move_direction = 0;
            int what = 0;
            if (who == WHITE_PLAYER)
            {
                myPawn = WHITE_PAWN;
                myKing = WHITE_KING;
                enemyPawn = BLACK_PAWN;
                enemyKing = BLACK_KING;
                move_direction = -1;
            }
            else
            {
                myPawn = BLACK_PAWN;
                myKing = BLACK_KING;
                enemyPawn = WHITE_PAWN;
                enemyKing = WHITE_KING;
                move_direction = 1;
            }

            for (int i = 0; i < 64; i++)
            {
                if ((current_board[i] == myPawn) || (current_board[i] == myKing))
                {

                    //szukaj ataku
                    if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction)
                    && ((check_board(current_board, i + 7 * move_direction) == enemyPawn) ||
                            (check_board(current_board, i + 7 * move_direction) == enemyKing))
                    && (i / 8 == (i + 14 * move_direction) / 8 - 2 * move_direction)
                    && (check_board(current_board, i + 14 * move_direction) == EMPTY))
                    {
                        is_attack_possible = true;
                       // matchHistory.Text += "atak7?" + i.ToString() + " " + (i + 7 * move_direction).ToString() + "\n";
                        clear_possible_boards();
                        Array.Copy(current_board, next_board, 64);
                        what = current_board[i];
                        if ((who == WHITE_PLAYER && (i + 14 * move_direction) / 8 == 0)
                        || (who == BLACK_PLAYER && (i + 14 * move_direction) / 8 == 7))
                            what = myKing;
                        next_board[i] = EMPTY;
                        next_board[i + 7 * move_direction] = EMPTY;
                        next_board[i + 14 * move_direction] = what;
                        get_attacks(next_board, i + 14 * move_direction, who, what);
                        if (possible_board_count > 0)
                        {
                            for (int j = 0; j < possible_board_count; j++)
                            {
                                Array.Copy(possible_boards[j], possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                        }
                        else
                        {
                            Array.Copy(next_board, possible_moves[possible_move_count], 64);
                            possible_move_count++;
                        }
                    }

                    if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction)
                        && ((check_board(current_board, i + 9 * move_direction) == enemyPawn) ||
                                (check_board(current_board, i + 9 * move_direction) == enemyKing))
                        && (i / 8 == (i + 18 * move_direction) / 8 - 2 * move_direction)
                        && (check_board(current_board, i + 18 * move_direction) == EMPTY))
                    {
                        is_attack_possible = true;
                        //matchHistory.Text += "atak9?" + i.ToString() + " " + (i + 9 * move_direction).ToString() + "\n";
                        clear_possible_boards();
                        Array.Copy(current_board, next_board, 64);
                        what = current_board[i];
                        if ((who == WHITE_PLAYER && (i + 18 * move_direction) / 8 == 0)
                        || (who == BLACK_PLAYER && (i + 18 * move_direction) / 8 == 7))
                            what = myKing;
                        next_board[i] = EMPTY;
                        next_board[i + 9 * move_direction] = EMPTY;
                        next_board[i + 18 * move_direction] = what;
                        get_attacks(next_board, i + 18 * move_direction, who, what);
                        if (possible_board_count > 0)
                        {
                            for (int j = 0; j < possible_board_count; j++)
                            {
                                Array.Copy(possible_boards[j], possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                        }
                        else
                        {
                            Array.Copy(next_board, possible_moves[possible_move_count], 64);
                            possible_move_count++;
                        }
                    }
                    //szukaj ataku krolem
                    if (current_board[i] == myKing)
                    {
                        move_direction *= (-1);
                        if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction)
                        && ((check_board(current_board, i + 7 * move_direction) == enemyPawn) ||
                                (check_board(current_board, i + 7 * move_direction) == enemyKing))
                        && (i / 8 == (i + 14 * move_direction) / 8 - 2 * move_direction)
                        && (check_board(current_board, i + 14 * move_direction) == EMPTY))
                        {
                            is_attack_possible = true;
                            //matchHistory.Text += "atak7?" + i.ToString() + " " + (i + 7 * move_direction).ToString() + "\n";
                            clear_possible_boards();
                            Array.Copy(current_board, next_board, 64);
                            what = current_board[i];
                            if ((who == WHITE_PLAYER && (i + 14 * move_direction) / 8 == 0)
                            || (who == BLACK_PLAYER && (i + 14 * move_direction) / 8 == 7))
                                what = myKing;
                            next_board[i] = EMPTY;
                            next_board[i + 7 * move_direction] = EMPTY;
                            next_board[i + 14 * move_direction] = what;
                            get_attacks(next_board, i + 14 * move_direction, who, what);
                            if (possible_board_count > 0)
                            {
                                for (int j = 0; j < possible_board_count; j++)
                                {
                                    Array.Copy(possible_boards[j], possible_moves[possible_move_count], 64);
                                    possible_move_count++;
                                }
                            }
                            else
                            {
                                Array.Copy(next_board, possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                        }

                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction)
                            && ((check_board(current_board, i + 9 * move_direction) == enemyPawn) ||
                                    (check_board(current_board, i + 9 * move_direction) == enemyKing))
                            && (i / 8 == (i + 18 * move_direction) / 8 - 2 * move_direction)
                            && (check_board(current_board, i + 18 * move_direction) == EMPTY))
                        {
                            is_attack_possible = true;
                            //matchHistory.Text += "atak9?" + i.ToString() + " " + (i + 9 * move_direction).ToString() + "\n";
                            clear_possible_boards();
                            Array.Copy(current_board, next_board, 64);
                            what = current_board[i];
                            if ((who == WHITE_PLAYER && (i + 18 * move_direction) / 8 == 0)
                            || (who == BLACK_PLAYER && (i + 18 * move_direction) / 8 == 7))
                                what = myKing;
                            next_board[i] = EMPTY;
                            next_board[i + 9 * move_direction] = EMPTY;
                            next_board[i + 18 * move_direction] = what;
                            get_attacks(next_board, i + 18 * move_direction, who, what);
                            if (possible_board_count > 0)
                            {
                                for (int j = 0; j < possible_board_count; j++)
                                {
                                    Array.Copy(possible_boards[j], possible_moves[possible_move_count], 64);
                                    possible_move_count++;
                                }
                            }
                            else
                            {
                                Array.Copy(next_board, possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                        }
                        move_direction *= (-1);
                    }
                    //koniec szukania ataku krolem

                    //koniec szukania ataku

                }
            }

            //if (is_attack_possible)
            //{
            //    matchHistory.Text += "possible attack!\n";
            //    int a = 0;
            //}
            //else
            //{
            //    //matchHistory.Text += "attack impossible!\n";
            //}
                    //szukaj ruchu po skosie
            if ((!is_attack_possible)||!enforced_kills)
            {

                for (int i = 0; i < 64; i++)
                {
                    if ((current_board[i] == myPawn) || (current_board[i] == myKing))
                    {

                        if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction) && (check_board(current_board, i + 7 * move_direction) == EMPTY))
                        {
                            Array.Copy(current_board, next_board, 64);
                            next_board[i] = EMPTY;
                            if ((who == WHITE_PLAYER && (i + 7 * move_direction) / 8 == 0)
                                || (who == BLACK_PLAYER && (i + 7 * move_direction) / 8 == 7))
                                next_board[i + 7 * move_direction] = myKing;
                            else
                                next_board[i + 7 * move_direction] = myPawn;
                            Array.Copy(next_board, possible_moves[possible_move_count], 64);
                            possible_move_count++;
                        }
                        if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction) && (check_board(current_board, i + 9 * move_direction) == EMPTY))
                        {
                            Array.Copy(current_board, next_board, 64);
                            next_board[i] = EMPTY;
                            if ((who == WHITE_PLAYER && (i + 9 * move_direction) / 8 == 0)
                                || (who == BLACK_PLAYER && (i + 9 * move_direction) / 8 == 7))
                                next_board[i + 9 * move_direction] = myKing;
                            else
                                next_board[i + 9 * move_direction] = myPawn;
                            Array.Copy(next_board, possible_moves[possible_move_count], 64);
                            possible_move_count++;
                        }

                        //szukaj ruchu skosem krolem
                        if (current_board[i] == myKing)
                        {
                            move_direction *= (-1);
                            if ((i / 8 == (i + 7 * move_direction) / 8 - move_direction) && (check_board(current_board, i + 7 * move_direction) == EMPTY))
                            {
                                Array.Copy(current_board, next_board, 64);
                                next_board[i] = EMPTY;
                                next_board[i + 7 * move_direction] = myKing;
                                Array.Copy(next_board, possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                            if ((i / 8 == (i + 9 * move_direction) / 8 - move_direction) && (check_board(current_board, i + 9 * move_direction) == EMPTY))
                            {
                                Array.Copy(current_board, next_board, 64);
                                next_board[i] = EMPTY;
                                next_board[i + 9 * move_direction] = myKing;
                                Array.Copy(next_board, possible_moves[possible_move_count], 64);
                                possible_move_count++;
                            }
                            move_direction *= (-1);
                        }
                    }
                        //koniec szukania ruchu po skosie krolem
                }
                    //koniec szukania po skosie
   
            }
            //zwracaj;
            possible_board_count = possible_move_count;
            if (possible_move_count > 0)
                
                return possible_moves;
            else
                return null;
        }

        int[] get_best_move_min_max(int[] board,int depth,int who,int by_who)
        {
            int possible_moves_on_this_level = 0;
            int[][] possible_boards_on_this_level = new int[128][];
            int[][] future_best_boards = new int[128][];
            int [] best_board = new int[64];
            float this_estimation = -32765;
            possible_boards_on_this_level = get_moves(board, who);
            possible_moves_on_this_level = possible_board_count;
            if (possible_moves_on_this_level == 0)
            {
                //int winner = check_winner(board);
                //if (winner == who || winner == 0)
                //{
                    return board;
                //}
                
            }
            if (depth == 0)
            {
                for (int i = 0; i < possible_moves_on_this_level; i++)
                {
                    //matchHistory.Text += "i<pmotl\n";
                    if (estimate_board(possible_boards_on_this_level[i], who, by_who) > this_estimation)
                        Array.Copy(possible_boards_on_this_level[i], best_board, 64);
                }
                return best_board;
            }
            else
            {
                who = who % 2 + 1;
                for (int i = 0; i < possible_moves_on_this_level; i++)
                {
                    //matchHistory.Text += "i<pmotl future\n";
                    future_best_boards[i] = get_best_move_min_max(possible_boards_on_this_level[i], depth - 1, who,by_who);
                    if (estimate_board(future_best_boards[i], who, by_who) > this_estimation)
                        Array.Copy(possible_boards_on_this_level[i], best_board, 64);
                }
                return best_board;
            }
            //return board;
        }

        float min_max(int[] board, int depth, int who, int by_who)
        {
            //matchHistory.Text += "in minmax\n";
            int possible_moves_on_this_level = 0;
            int[][] possible_boards_on_this_level = new int[128][];
            int[][] future_best_boards = new int[128][];
            int[] best_board = new int[64];
            float this_estimation = 0;
            float max_estimation = -32765;
            possible_boards_on_this_level = get_moves(board, who);
            //matchHistory.Text += possible_board_count.ToString()+ "\n";
            possible_moves_on_this_level = possible_board_count;
            //matchHistory.Text += "pb= " + depth.ToString()+" " + possible_moves_on_this_level.ToString() + "\n";
            //matchHistory.Text += "alfa\n";
            if (estimate_board(board,who,by_who) < ALPHA)
            {
                //matchHistory.Text += "alpha prune\n";
                return estimate_board(board, who, by_who);
            }
            if (possible_moves_on_this_level == 0)
            {
                int winner = check_winner(board);
                if (winner == who)
                {
                    return WIN_VALUE;
                }
                else if (winner == who % 2 + 1)
                {
                    return LOSE_VALUE;
                }
                else
                {
                    return DRAW_VALUE;
                }

            }
            if (depth == 0)
            {
                //matchHistory.Text += estimate_board(board,who,by_who).ToString()+"\n";
                return estimate_board(board,who,by_who);
            }
            else
            {
                //matchHistory.Text += "depth!= 0\n";
                who = who % 2 + 1;
                for (int i = 0; i < possible_moves_on_this_level; i++)
                {
                    this_estimation = min_max(possible_boards_on_this_level[i], depth - 1, who, by_who);

                    if (this_estimation > max_estimation)
                        max_estimation = this_estimation;
                }
                return max_estimation;
            }
            //return board;
        }
        void execute_move(int who)
        {
            current_move++;
            int[] old_board = new int[64];
            Array.Copy(board, old_board, 64);
            int[][]future_boards = new int [128][];
            current_player = who;

            //for (int k = 0; k < 3; k++)
            //{
                //future_boards[0] = get_best_move(get_moves(board, who), possible_board_count, who);
            //}
            
            future_boards = get_moves(board, who);
            //int pb=1;
            int pb = possible_board_count;
            //matchHistory.Text = "upb= " + pb.ToString() +"\n";

            float[] estimations = new float[128];
            for (int i = 0; i < pb; i++)
            {
                //matchHistory.Text += "minmax\n";
                estimations[i] = min_max(future_boards[i], TREE_DEPTH, who%2+1, who);
            }
            float max_estimation = -20000.0f;
            int max_estimated = -1;
            for (int i = 0; i < pb; i++)
            {
                if (max_estimation < estimations[i])
                {
                    max_estimated = i;
                    max_estimation = estimations[i];
                }
            }
            
            //temp_board = get_best_move(get_moves(board, who), possible_board_count, who);

            //temp_board = get_best_move_min_max(board, 1, current_player, current_player);

            if (max_estimated==-1)//nie udało sie wybrać ruchu
            {
                
                game_over = true;
                int winner = check_winner(board);
                if (notation)
                {

                    if (winner == WHITE_PLAYER)
                    {
                        matchHistory.Text += "WW\n";
                    }
                    else if (winner == BLACK_PLAYER)
                    {
                        matchHistory.Text += "BW\n";
                    }
                    else
                    {
                        matchHistory.Text += "Draw\n";
                    }
                }
                if (!debug_mode)
                {
                    button_wm.Enabled = false;
                    button_bm.Enabled = false;
                }
            }
           
            else//wykonaj wybrany ruch
            {

                Array.Copy(future_boards[max_estimated],temp_board,64);

                int start_pos=0;
                bool is_kill = false;
                int end_pos=0;
                if (who == WHITE_PLAYER)
                {
                    for (int i = 0; i < BOARD_SIZE * BOARD_SIZE; i++)
                    {
                        if ((old_board[i] == WHITE_KING || old_board[i] == WHITE_PAWN) && temp_board[i] == EMPTY)
                            start_pos = i;
                        if ((temp_board[i] == WHITE_KING || temp_board[i] == WHITE_PAWN) && old_board[i] == EMPTY)
                            end_pos = i;
                        if ((old_board[i] == BLACK_KING || old_board[i] == BLACK_PAWN) && temp_board[i] == EMPTY)
                            is_kill = true;
                    }
                    if (notation)
                    {
                        if (official_notation)
                        {
                            if (is_kill)
                                matchHistory.Text += (current_move / 2 + 1).ToString() + ". " + (start_pos / 2 + 1).ToString() + "x" + (end_pos / 2 + 1).ToString() + " ";
                            else
                                matchHistory.Text += (current_move / 2 + 1).ToString() + ". " + (start_pos / 2 + 1).ToString() + "-" + (end_pos / 2 + 1).ToString() + " ";
                        }
                        else
                        {
                            if (is_kill)
                                matchHistory.Text += (current_move / 2 + 1).ToString() + ". " + start_pos.ToString() + "x" + end_pos.ToString() + " ";
                            else
                                matchHistory.Text += (current_move / 2 + 1).ToString() + ". " + start_pos.ToString() + "-" + end_pos.ToString() + " ";
                        }
                    }
                }
                else
                {
                    for (int i = 0; i < BOARD_SIZE * BOARD_SIZE; i++)
                    {
                        if ((old_board[i] == BLACK_KING || old_board[i] == BLACK_PAWN) && temp_board[i] == EMPTY)
                            start_pos = i;
                        if ((temp_board[i] == BLACK_KING || temp_board[i] == BLACK_PAWN) && old_board[i] == EMPTY)
                            end_pos = i;
                        if ((old_board[i] == WHITE_KING || old_board[i] == WHITE_PAWN) && temp_board[i] == EMPTY)
                            is_kill = true;
                    }
                    if (notation)
                    {
                        if (official_notation)
                        {
                            if (is_kill)
                                matchHistory.Text += (start_pos / 2 + 1).ToString() + "x" + (end_pos / 2 + 1).ToString() + " \n";
                            else
                                matchHistory.Text += (start_pos / 2 + 1).ToString() + "-" + (end_pos / 2 + 1).ToString() + " \n";
                        }
                        else
                        {
                            if (is_kill)
                                matchHistory.Text += start_pos.ToString() + "x" + end_pos.ToString() + " \n";
                            else
                                matchHistory.Text += start_pos.ToString() + "-" + end_pos.ToString() + " \n";
                        }
                    }
                }
                //if(who==WHITE_PLAYER)
                //    matchHistory.Text += (current_move / 2).ToString() + ". "+start_pos.ToString() +"-" + end_pos.ToString()+" ";
                //else
                //    matchHistory.Text += start_pos.ToString() + "-" + end_pos.ToString() + "\n";

                int winner = check_winner(board);
                if (winner != -1)
                {
                    game_over = true;
                    if (winner == WHITE_PLAYER)
                    {
                        matchHistory.Text += "WW\n";
                    }
                    else if (winner == BLACK_PLAYER)
                    {
                        matchHistory.Text += "BW\n";
                    }
                    else
                    {
                        matchHistory.Text += "Draw\n";
                    }
                    if (!debug_mode)
                    {
                        button_wm.Enabled = false;
                        button_bm.Enabled = false;
                    }
                }
                else if (!debug_mode)
                {
                    if (current_player == WHITE_PLAYER)
                    {
                        button_wm.Enabled = false;
                        button_bm.Enabled = true;
                    }
                    else
                    {
                        button_wm.Enabled = true;
                        button_bm.Enabled = false;
                    }
                }

                board = temp_board;



                //if(c)
            }
            if (refresh)
            {
                update_board_presentation();
            }
        }
        private void button_wm_Click(object sender, EventArgs e)
        {
            execute_move(WHITE_PLAYER);
            white_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
            current_player = BLACK_PLAYER;
            
        }

        private void button_bm_Click(object sender, EventArgs e)
        {
            execute_move(BLACK_PLAYER);
            black_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
            current_player = WHITE_PLAYER;
        }

        private void button_estimate_Click(object sender, EventArgs e)
        {
            white_estimation.Text = (estimate_board(board, WHITE_PLAYER, WHITE_PLAYER)).ToString("0.0000");
            black_estimation.Text = (estimate_board(board, BLACK_PLAYER, BLACK_PLAYER)).ToString("0.0000");
        }

        private void button_autoplay_Click(object sender, EventArgs e)
        {
            //int winner = -1;
            for (int i = 0; (i < autos)&&!game_over; i++)
            {
                execute_move(WHITE_PLAYER);
                //winner = check_winner(board);
                //if()
                white_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
                System.Threading.Thread.Sleep(wait_time);
                if (game_over)
                {
                    break;
                }
                execute_move(BLACK_PLAYER);          
                black_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
                System.Threading.Thread.Sleep(wait_time);
            }
        }

        void showValues()
        {
            textWPV.Text = pawn_value[0].ToString("0.00000");
            textBPV.Text = pawn_value[1].ToString("0.00000");

            textWKM.Text = king_multiplier[0].ToString("0.00000");
            textBKM.Text = king_multiplier[1].ToString("0.00000");

            textWBM.Text = border_multiplier[0].ToString("0.00000");
            textBBM.Text = border_multiplier[1].ToString("0.00000");

            textWCM.Text = corner_multiplier[0].ToString("0.00000");
            textBCM.Text = corner_multiplier[1].ToString("0.00000");

            textWCeM.Text = center_multiplier[0].ToString("0.00000");
            textBCeM.Text = center_multiplier[1].ToString("0.00000");

            textWDiM.Text = distance_multiplier[0].ToString("0.00000");
            textBDiM.Text = distance_multiplier[1].ToString("0.00000");

            textWAM.Text = attack_multiplier[0].ToString("0.00000");
            textBAM.Text = attack_multiplier[1].ToString("0.00000");

            textWDaM.Text = danger_multiplier[0].ToString("0.00000");
            textBDaM.Text = danger_multiplier[1].ToString("0.00000");

            textWDeM.Text = defense_multiplier[0].ToString("0.00000");
            textBDeM.Text = defense_multiplier[1].ToString("0.00000");

            textWA.Text = aggresivity_multiplier[0].ToString("0.00000");
            textBA.Text = aggresivity_multiplier[1].ToString("0.00000");

            textWTM.Text = time_multiplier[0].ToString("0.00000");
            textBTM.Text = time_multiplier[1].ToString("0.00000");
        }
        void update_parameters()
        {
            pawn_value[0] = float.Parse(textWPV.Text);
            pawn_value[1] = float.Parse(textBPV.Text);

            king_multiplier[0] = float.Parse(textWKM.Text);
            king_multiplier[1] = float.Parse(textBKM.Text);

            border_multiplier[0] = float.Parse(textWBM.Text);
            border_multiplier[1] = float.Parse(textBBM.Text);

            corner_multiplier[0] = float.Parse(textWCM.Text);
            corner_multiplier[1] = float.Parse(textBCM.Text);

            center_multiplier[0] = float.Parse(textWCeM.Text);
            center_multiplier[1] = float.Parse(textBCeM.Text);

            distance_multiplier[0] = float.Parse(textWDiM.Text);
            distance_multiplier[1] = float.Parse(textBDiM.Text);

            attack_multiplier[0] = float.Parse(textWAM.Text);
            attack_multiplier[1] = float.Parse(textBAM.Text);

            danger_multiplier[0] = float.Parse(textWDaM.Text);
            danger_multiplier[1] = float.Parse(textBDaM.Text);

            defense_multiplier[0] = float.Parse(textWDeM.Text);
            defense_multiplier[1] = float.Parse(textBDeM.Text);

            aggresivity_multiplier[0] = float.Parse(textWA.Text);
            aggresivity_multiplier[1] = float.Parse(textBA.Text);

            time_multiplier[0] = float.Parse(textWTM.Text);
            time_multiplier[1] = float.Parse(textBTM.Text);
        }
        private void updateFunction_Click(object sender, EventArgs e)
        {
            update_parameters();        
        }

        private void buttonWMutate_Click(object sender, EventArgs e)
        {
            mutate_white();      
            showValues();
            update_parameters();
        }

        void mutate_white()
        {
            int player = 0;
            if (checkBox1.Checked)
                pawn_value[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox2.Checked)
                king_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox3.Checked)
                border_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox4.Checked)
                corner_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox5.Checked)
                center_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox6.Checked)
                distance_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox7.Checked)
                attack_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox8.Checked)
                danger_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox9.Checked)
                defense_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox10.Checked)
                aggresivity_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox11.Checked)
                time_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;
        }

        void mutate_black()
        {
            int player = 1;
            if (checkBox24.Checked)
                pawn_value[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox23.Checked)
                king_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox22.Checked)
                border_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox21.Checked)
                corner_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox20.Checked)
                center_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox19.Checked)
                distance_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox18.Checked)
                attack_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox17.Checked)
                danger_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox16.Checked)
                defense_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox15.Checked)
                aggresivity_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;

            if (checkBox14.Checked)
                time_multiplier[player] *= 1.0f + (float)(random.NextDouble() / 100) - 0.005f;
        }

        private void buttonBMutate_Click(object sender, EventArgs e)
        {

            mutate_black();
            showValues();
            update_parameters();
        }

        private void checkDebug_CheckedChanged(object sender, EventArgs e)
        {
            debug_mode = !debug_mode;
            if (debug_mode == true)
            {
                button_bm.Enabled = true;
                button_wm.Enabled = true;
            }
            else
            {
                if (current_player== WHITE_PLAYER)
                {
                    button_wm.Enabled = true;
                    button_bm.Enabled = false;
                }
                else
                {
                    button_wm.Enabled = false;
                    button_bm.Enabled = true;
                }
            }

        }

        private void savebutton_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Checkers Board|*.brd";
            saveFileDialog1.Title = "Save a current game state positions to file";
            saveFileDialog1.ShowDialog();

            if (saveFileDialog1.FileName != "")
            {
                String s = "";
                for (int i = 0; i < 64; i++)
                {
                    s += board[i].ToString() + "_";
                }
                s += current_player.ToString()+"_";
                s += matchHistory.Text;
                System.IO.File.WriteAllText(saveFileDialog1.FileName, s);             
            }
        }

        private void openbutton_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Checkers Board|*.brd";
            openFileDialog1.Title = "Select a game state to open";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String s = System.IO.File.ReadAllText(openFileDialog1.FileName);
                String[] positions = s.Split('_');
                bool result = true;
                for (int i = 0; i < 64; i++)
                {
                    result = Int32.TryParse(positions[i], out board[i]);
                    if (result != true)
                    {
                        MessageBox.Show("Wrong board data!");
                    }
                }
                result = Int32.TryParse(positions[64], out current_player);
                if (result != true)
                {
                    MessageBox.Show("Wrong player data!");
                }
                matchHistory.Text = positions[65];
            }
            if (!debug_mode)
            {
                if (current_player == WHITE_PLAYER)
                {
                    button_wm.Enabled = false;
                    button_bm.Enabled = true;
                }
                else
                {
                    button_wm.Enabled = true;
                    button_bm.Enabled = false;
                }
            }
            update_board_presentation();
        }

        private void checkNotation_CheckedChanged(object sender, EventArgs e)
        {
            official_notation = checkNotation.Checked;
            update_board_presentation();
        }

        private void checkEnforced_CheckedChanged(object sender, EventArgs e)
        {
            enforced_kills = checkEnforced.Checked;
        }

        private void savewbutton1_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Estimation Function Parameters|*.efp";
            saveFileDialog1.Title = "Save current function parameters to file";
            saveFileDialog1.ShowDialog();

            if (saveFileDialog1.FileName != "")
            {
                String s = "";
                s += textWPV.Text + " ";
                s += textWKM.Text + " ";
                s += textWBM.Text + " ";
                s += textWCM.Text + " ";
                s += textWCeM.Text + " ";
                s += textWDiM.Text + " ";
                s += textWAM.Text + " ";
                s += textWDaM.Text + " ";
                s += textWDeM.Text + " ";
                s += textWA.Text + " ";
                s += textWTM.Text + " ";
                System.IO.File.WriteAllText(saveFileDialog1.FileName, s);
            }
        }

        private void savebbutton1_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "Estimation Function Parameters|*.efp";
            saveFileDialog1.Title = "Save current function parameters to file";
            saveFileDialog1.ShowDialog();

            if (saveFileDialog1.FileName != "")
            {
                String s = "";
                s += textBPV.Text+" ";
                s += textBKM.Text + " ";
                s += textBBM.Text + " ";
                s += textBCM.Text + " ";
                s += textBCeM.Text + " ";
                s += textBDiM.Text + " ";
                s += textBAM.Text + " ";
                s += textBDaM.Text + " ";
                s += textBDeM.Text + " ";
                s += textBA.Text + " ";
                s += textBTM.Text + " ";
                System.IO.File.WriteAllText(saveFileDialog1.FileName, s);
            }
        }

        private void openwbutton1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Estimation Function Parameters|*.efp";
            openFileDialog1.Title = "Select saved function parameters to open";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String s = System.IO.File.ReadAllText(openFileDialog1.FileName);
                String[] parameters = s.Split(' ');
                int player = 0;
                pawn_value[player] = float.Parse(parameters[0]);
                king_multiplier[player] = float.Parse(parameters[1]);
                border_multiplier[player] = float.Parse(parameters[2]);
                corner_multiplier[player] = float.Parse(parameters[3]);
                center_multiplier[player] = float.Parse(parameters[4]);
                distance_multiplier[player] = float.Parse(parameters[5]);
                attack_multiplier[player] = float.Parse(parameters[6]);
                danger_multiplier[player] = float.Parse(parameters[7]);
                defense_multiplier[player] = float.Parse(parameters[8]);
                aggresivity_multiplier[player] = float.Parse(parameters[9]);
                time_multiplier[player] = float.Parse(parameters[10]);
                showValues();            
            }
        }

        private void openbbutton1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "Estimation Function Parameters|*.efp";
            openFileDialog1.Title = "Select saved function parameters to open";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                String s = System.IO.File.ReadAllText(openFileDialog1.FileName);
                String[] parameters = s.Split(' ');
                int player = 1;
                pawn_value[player] = float.Parse(parameters[0]);
                king_multiplier[player] = float.Parse(parameters[1]);
                border_multiplier[player] = float.Parse(parameters[2]);
                corner_multiplier[player] = float.Parse(parameters[3]);
                center_multiplier[player] = float.Parse(parameters[4]);
                distance_multiplier[player] = float.Parse(parameters[5]);
                attack_multiplier[player] = float.Parse(parameters[6]);
                danger_multiplier[player] = float.Parse(parameters[7]);
                defense_multiplier[player] = float.Parse(parameters[8]);
                aggresivity_multiplier[player] = float.Parse(parameters[9]);
                time_multiplier[player] = float.Parse(parameters[10]);
                showValues();
            }
        }

        private void checkBox12_CheckedChanged(object sender, EventArgs e)
        {
            checkBox1.Checked=checkBox12.Checked;
            checkBox2.Checked = checkBox12.Checked;
            checkBox3.Checked = checkBox12.Checked;
            checkBox4.Checked = checkBox12.Checked;
            checkBox5.Checked = checkBox12.Checked;
            checkBox6.Checked = checkBox12.Checked;
            checkBox7.Checked = checkBox12.Checked;
            checkBox8.Checked = checkBox12.Checked;
            checkBox9.Checked = checkBox12.Checked;
            checkBox10.Checked = checkBox12.Checked;
            checkBox11.Checked = checkBox12.Checked;
        }

        private void checkBox13_CheckedChanged(object sender, EventArgs e)
        {
            checkBox14.Checked = checkBox13.Checked;
            checkBox15.Checked = checkBox13.Checked;
            checkBox16.Checked = checkBox13.Checked;
            checkBox17.Checked = checkBox13.Checked;
            checkBox18.Checked = checkBox13.Checked;
            checkBox19.Checked = checkBox13.Checked;
            checkBox20.Checked = checkBox13.Checked;
            checkBox21.Checked = checkBox13.Checked;
            checkBox22.Checked = checkBox13.Checked;
            checkBox23.Checked = checkBox13.Checked;
            checkBox24.Checked = checkBox13.Checked;
        }

        private void clonewarsbutton1_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < clones; i++)
            {
                reset_board();
                game_over = false;
                current_player = WHITE_PLAYER;
                while (!game_over)
                {
                    execute_move(WHITE_PLAYER);
                    white_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
                    System.Threading.Thread.Sleep(wait_time);
                    if (game_over)
                    {
                        break;
                    }
                    execute_move(BLACK_PLAYER);
                    black_estimation.Text = (estimate_board(board, current_player, current_player)).ToString("0.0000");
                    System.Threading.Thread.Sleep(wait_time);
                }
                int winner = check_winner(board);
                if (winner == WHITE_PLAYER)
                {
                    pawn_value[1] = pawn_value[0];
                    king_multiplier[1] = king_multiplier[0];
                    border_multiplier[1] = border_multiplier[0];
                    corner_multiplier[1] = corner_multiplier[0];
                    center_multiplier[1] = center_multiplier[0];
                    distance_multiplier[1] = distance_multiplier[0];
                    attack_multiplier[1] = attack_multiplier[0];
                    danger_multiplier[1] = danger_multiplier[0];
                    defense_multiplier[1] = defense_multiplier[0];
                    aggresivity_multiplier[1] = aggresivity_multiplier[0];
                    time_multiplier[1] = time_multiplier[0];
                    mutate_black();
                }
                else
                {
                    pawn_value[0] = pawn_value[1];
                    king_multiplier[0] = king_multiplier[1];
                    border_multiplier[0] = border_multiplier[1];
                    corner_multiplier[0] = corner_multiplier[1];
                    center_multiplier[0] = center_multiplier[1];
                    distance_multiplier[0] = distance_multiplier[1];
                    attack_multiplier[0] = attack_multiplier[1];
                    danger_multiplier[0] = danger_multiplier[1];
                    defense_multiplier[0] = defense_multiplier[1];
                    aggresivity_multiplier[0] = aggresivity_multiplier[1];
                    time_multiplier[0] = time_multiplier[1];
                    mutate_white();
                    
                }
                
            }
            showValues();
        }

        private void checkRefresh_CheckedChanged(object sender, EventArgs e)
        {
            refresh = checkRefresh.Checked;
        }

        private void checkUseHistory_CheckedChanged(object sender, EventArgs e)
        {
            notation = checkUseHistory.Checked;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            Int32.TryParse(textBox1.Text, out wait_time);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            white_estimation.Text = (estimate_board(board, WHITE_PLAYER, WHITE_PLAYER)).ToString("0.0000");
            black_estimation.Text = (estimate_board(board, BLACK_PLAYER, BLACK_PLAYER)).ToString("0.0000");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            matchHistory.Text = "";
        }

        private void clonefightBox1_TextChanged(object sender, EventArgs e)
        {
            Int32.TryParse(clonefightBox1.Text, out clones);
        }

        private void autoplayBox1_TextChanged(object sender, EventArgs e)
        {
            Int32.TryParse(clonefightBox1.Text, out autos);
        }
    }
}